/**
 *  Copyright (c) 2015,
 *  BTC Embedded Systems AG, Oldenburg, Germany
 *  All rights reserved
 *  ---------------------------------------------------------
 *  $Author: $
 *  $Date:  $
 *  $Revision: $
 **/

package com.btc.ep.base.bl.impl;

import java.util.List;

import javax.jdo.annotations.Index;

import com.btc.ep.base.bl.VectorElement;

/**
 * This class implements the VectorImpl
 * 
 * It's a 'Step'
 */
public class VectorElementImpl extends ModelElementImpl implements VectorElement {

    @Index
    private long vectorElementCollectionRef;
    @Index
    private long stepOffset;
    private List<Float> values;
    
    // TODO Step

    /**
     * JPA Entity Default constructor
     * <p>The default constructor must be a public or protected zero-argument constructor.</p>
     */
    protected VectorElementImpl() {
    }

    /**
     * Constructor
     *
     * @param step - long
     * @param value - float
     */
    @Deprecated
    public VectorElementImpl(long vectorElementCollectionRef, long step, List<Float> values) {
        this.vectorElementCollectionRef = vectorElementCollectionRef;
        this.values = values;
        
        setStepOffset(step);
    }
    
    /**
     * Constructor
     *
     * @param step - long
     * @param value - float
     */
    public VectorElementImpl(long step, List<Float> values) {
        this.values = values;
        
        setStepOffset(step);
    }

    @Override
    public void setValue(List<Float> values) {
        this.values = values;
    }

    @Override
    public List<Float> getValue() {
        return this.values;
    }

    @Override
    public long getStepOffset() {
        return stepOffset;
    }

    @Override
    public void setStepOffset(long stepOffset) {
        this.stepOffset = stepOffset;
    }
    
    @Override
    public long getStep() {
        return stepOffset;
    }

    @Override
    public void setStep(long step) {
        this.stepOffset = step; // TODO
    }

    @Override
    public void setVectorElementCollectionRef(long vectorElementCollectionRef) {
        this.vectorElementCollectionRef = vectorElementCollectionRef;
    }
    

}
